#include <stdio.h>
#include <stdlib.h>
#include <termios.h>

int main(int argc, char **argv) {
  int ch;
  unsigned char buffer[4];
  char *compare = "exit";
  struct termios ios;

  printf("\nos2keys by Rocco Caputo <troc@nexi.com>");
  printf("\nDisplays slrn key sequences for OS/2 keystrokes.  For example, press");
  printf("\nALT+F12 to see how slrn will recognize that key.\n\n");
  printf("Type exit (all lowercase) to exit.  You don't have to press ENTER.\n\n");

  if (tcgetattr(0, &ios)) {
    perror("tcgetattr");
    exit(1);
  }

  ios.c_lflag &= ~(ECHO | ISIG | ICANON);
  ios.c_cc[VMIN] = ios.c_cc[VTIME] = 0;

  if (tcsetattr(0, TCSANOW, &ios)) {
    perror("tcsetattr");
    exit(1);
  }

  for (;;) {
    while ((ch = getchar()) < 0) {
      _sleep2(50);
    }
   
    if (ch<' ') {
      printf("^%c", ch+64);
    }
    else if (ch>'~') {
      printf("\\x%.2x", ch);
    }
    else {
      printf("%c", ch);
    }

    buffer[0] = buffer[1];
    buffer[1] = buffer[2];
    buffer[2] = buffer[3];
    buffer[3] = ch;

    if (!memcmp((void *)buffer,(void *)compare,4)) {
      break;
    }
  }

  printf("\n");

  return(0);
}
